#ifndef _INC_SELLIB_CFPSTIMER
#define _INC_SELLIB_CFPSTIMER

#define FPSTIMER_NOWAIT (DWORD)0

#define	FPSTIMER_F_FPS (float)(0.0f)
#define	FPSTIMER_I_FPS (DWORD)(0)


/*----------------------------------------------------------------------------*
|	FPS^C}[NX
*----------------------------------------------------------------------------*/
typedef class CFpsTimer
{
private:

	LONGLONG	m_llLastTime;			// 1t[XṼ^C
	LONGLONG	m_llWaitTime;			// 1t[̑ҋ@
	LONGLONG	m_llFrameTime[64];		// t[XṼ^Cۑ
	LONGLONG	m_llFpsNextTime;		// FPSv̎̃^C
	LONGLONG	m_llFpsLastTime;		// FPSṽ^C

	DWORD		m_dwLastTime;			// 1t[XṼ^C
	DWORD		m_dwWaitTime;			// 1t[̑ҋ@(Œ菭ms)
	DWORD		m_dwNowWaitTime;		// ҋ@鎞(Œ菭ms)
	DWORD		m_dwFrameTime[64];		// t[XṼ^Cۑ
	DWORD		m_dwFpsNextTime;		// FPSv̎̃^C
	DWORD		m_dwFpsLastTime;		// FPSṽ^C

	DWORD		m_dwFPS;				// FPSl
	FLOAT		m_fTimeElapsed;			// 1t[̌oߎ
	BOOL		m_bHighTimer;			// x^C}gptO
	DWORD		m_dwFrameTimeCount;		// t[^C̃JEg
	DWORD		m_dwFrameCount;			// t[JEg
	DWORD		m_dwFps;				// 1bXVFPSl
	FLOAT		m_fFps;					// 1bXVFPSl
	FLOAT		m_fTimeScale;			// ^C̔{

	static LONGLONG	m_llTicksPerSecond;	// 1bԕӂ̃CNgl
	static BOOL		m_bHighAccurate;	// x^C}gp\tO

	static TIMECAPS	m_tc;
	static UINT		m_timer_res;
	static DWORD	m_dwReference;

public:

	// RXgN^
	CFpsTimer( DWORD dwFPS=FPSTIMER_NOWAIT, BOOL bHighTimer=FALSE );

	virtual ~CFpsTimer();

	// t[ҋ@
	void WaitFrame( void );

	// FPSl̐ݒ
	void SetFPSValue( DWORD dwFPS=FPSTIMER_NOWAIT );

	// ݂̐ݒFPSl
	DWORD GetFPSValue( void ){ return m_dwFPS; }

	// 1t[̌oߎԎ擾
	FLOAT GetElapsed( void ){ return m_fTimeElapsed; }

	// FPS̑l擾()
	DWORD GetFPS( DWORD type, bool real=true );

	// FPS̑l擾()
	float GetFPS( float type, bool real=true );

	// x^C}̃JEgl擾
	LONGLONG GetPerformanceCounter( void )
	{ 
		LONGLONG count = 0;
		::QueryPerformanceCounter( ( LARGE_INTEGER* )&count );
		return count;
	}

	// x^C}1bԕӂ̃CNgl擾
	LONGLONG GetPerformanceFrequency( void ){ return m_llTicksPerSecond; }

	// x^C}g邩ǂ
	BOOL IsPerformanceCounter( void ){ return m_bHighAccurate; }

	// x^C}gp邩
	void UsePerformanceCounter( BOOL bHighTimer=TRUE )
	{ 
		if( (m_bHighTimer=bHighTimer) )
		{	m_fTimeScale=(m_bHighAccurate)?(1.0f/m_llTicksPerSecond):(0.001f);//(1.0/1000);
		}else
		{	m_fTimeScale=0.001f;}

		// Zbg
		SetFPSValue( m_dwFPS );
	}

}CFPSTIMER, FAR* LPCFPSTIMER;


#endif /* _INC_SELLIB_CFPSTIMER */